Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.poi.xssf.usermodel
Class XSSFSheet

    java.lang.Object
      org.apache.poi.POIXMLDocumentPart
          org.apache.poi.xssf.usermodel.XSSFSheet

All Implemented Interfaces:
  org.apache.poi.ss.usermodel.Sheet, poi.support.Iterable

Direct Known Subclasses:
  XSSFChartSheet, XSSFDialogsheet

    public class XSSFSheet

extends POIXMLDocumentPart
implements org.apache.poi.ss.usermodel.Sheet

High level representation of a SpreadsheetML worksheet.

Sheets are the central structures within a workbook, and are where a user does most of his spreadsheet work. The most common type of sheet is the worksheet, which is represented as a grid of cells. Worksheet cells can contain text, numbers, dates, and formulas. Cells can also be formatted.

Field Summary

Fields inherited from class org.apache.poi.POIXMLDocumentPart
`DEFAULT_XML_OPTIONS`

Fields inherited from interface org.apache.poi.ss.usermodel.Sheet
`BottomMargin, FooterMargin, HeaderMargin, LeftMargin, PANE_LOWER_LEFT, PANE_LOWER_RIGHT, PANE_UPPER_LEFT, PANE_UPPER_RIGHT, RightMargin, TopMargin`

Method Summary
`void` | `addHyperlink(XSSFHyperlink hyperlink)` Register a hyperlink in the collection of hyperlinks on this sheet
`int` | `addMergedRegion(org.apache.poi.ss.util.CellRangeAddress region)` Adds a merged region of cells (hence those cells form one).
`void` | `addValidationData(org.apache.poi.ss.usermodel.DataValidation dataValidation)`
`void` | `autoSizeColumn(int column)` Adjusts the column width to fit the contents.
`void` | `autoSizeColumn(int column, boolean useMergedCells)` Adjusts the column width to fit the contents.
`org.apache.poi.ss.usermodel.Comment` | `createComment()` Deprecated. since Nov 2009 this method is not compatible with the common SS interfaces, use `(org.apache.poi.ss.usermodel.ClientAnchor)` instead
`org.apache.poi.ss.usermodel.Drawing` | `createDrawingPatriarch()` Create a new SpreadsheetML drawing.
`void` | `createFreezePane(int colSplit, int rowSplit)` Creates a split (freezepane).
`void` | `createFreezePane(int colSplit, int rowSplit, int leftmostColumn, int topRow)` Creates a split (freezepane).
`org.apache.poi.ss.usermodel.Row` | `createRow(int rownum)` Create a new row within the sheet and return the high level representation
`void` | `createSplitPane(int xSplitPos, int ySplitPos, int leftmostColumn, int topRow, int activePane)` Creates a split pane.
`XSSFTable` | `createTable()` Creates a new Table, and associates it with this Sheet
`void` | `disableLocking()` Disable sheet protection
`void` | `enableLocking()` Enable sheet protection
`int` | `findEndOfRowOutlineGroup(int row)`
`java.lang.String` | `getActiveCell()` Return location of the active cell, e.g.
`boolean` | `getAutobreaks()` Flag indicating whether the sheet displays Automatic Page Breaks.
`org.apache.poi.ss.usermodel.Comment` | `getCellComment(int row, int column)`
`int[]` | `getColumnBreaks()` Vertical page break information used for print layout view, page layout view, drawing print breaks in normal view, and for printing the worksheet.
`ColumnHelper` | `getColumnHelper()`
`org.apache.poi.ss.usermodel.CellStyle` | `getColumnStyle(int column)` Returns the CellStyle that applies to the given (0 based) column, or null if no style has been set for that column
`int` | `getColumnWidth(int columnIndex)` Get the actual column width (in units of 1/256th of a character width )
`org.openxmlformats.schemas.spreadsheetml.x2006.main.CTWorksheet` | `getCTWorksheet()` Provide access to the CTWorksheet bean holding this sheet's data
`org.apache.poi.ss.usermodel.DataValidationHelper` | `getDataValidationHelper()`
`java.util.List` | `getDataValidations()`
`int` | `getDefaultColumnWidth()` Get the default column width for the sheet (if the columns do not define their own width) in characters.
`short` | `getDefaultRowHeight()` Get the default row height for the sheet (if the rows do not define their own height) in twips (1/20 of a point)
`float` | `getDefaultRowHeightInPoints()` Get the default row height for the sheet measued in point size (if the rows do not define their own height).
`boolean` | `getDisplayGuts()` Get whether to display the guts or not, default value is true
`org.apache.poi.ss.usermodel.Footer` | `getEvenFooter()` Returns the even footer.
`org.apache.poi.ss.usermodel.Header` | `getEvenHeader()` Returns the even header.
`org.apache.poi.ss.usermodel.Footer` | `getFirstFooter()` Returns the first page footer.
`org.apache.poi.ss.usermodel.Header` | `getFirstHeader()` Returns the first page header.
`int` | `getFirstRowNum()` Gets the first row on the sheet
`boolean` | `getFitToPage()` Flag indicating whether the Fit to Page print option is enabled.
`org.apache.poi.ss.usermodel.Footer` | `getFooter()` Returns the default footer for the sheet, creating one as needed.
`boolean` | `getForceFormulaRecalculation()` Whether Excel will be asked to recalculate all formulas when the workbook is opened.
`org.apache.poi.ss.usermodel.Header` | `getHeader()` Returns the default header for the sheet, creating one as needed.
`boolean` | `getHorizontallyCenter()` Determine whether printed output for this sheet will be horizontally centered.
`XSSFHyperlink` | `getHyperlink(int row, int column)`
`int` | `getLastRowNum()`
`short` | `getLeftCol()`
`double` | `getMargin(short margin)` Gets the size of the margin in inches.
`org.apache.poi.ss.util.CellRangeAddress` | `getMergedRegion(int index)`
`int` | `getNumHyperlinks()`
`int` | `getNumMergedRegions()` Returns the number of merged regions defined in this worksheet
`org.apache.poi.ss.usermodel.Footer` | `getOddFooter()` Returns the odd footer.
`org.apache.poi.ss.usermodel.Header` | `getOddHeader()` Returns the odd header.
`org.apache.poi.hssf.util.PaneInformation` | `getPaneInformation()` Returns the information regarding the currently configured pane (split or freeze).
`int` | `getPhysicalNumberOfRows()` Returns the number of phsyically defined rows (NOT the number of rows in the sheet)
`org.apache.poi.ss.usermodel.PrintSetup` | `getPrintSetup()` Gets the print setup object.
`boolean` | `getProtect()` Answer whether protection is enabled or disabled
`org.apache.poi.ss.usermodel.Row` | `getRow(int rownum)` Returns the logical row ( 0-based).
`int[]` | `getRowBreaks()` Horizontal page break information used for print layout view, page layout view, drawing print breaks in normal view, and for printing the worksheet.
`boolean` | `getRowSumsBelow()` Flag indicating whether summary rows appear below detail in an outline, when applying an outline.
`boolean` | `getRowSumsRight()` Flag indicating whether summary columns appear to the right of detail in an outline, when applying an outline.
`boolean` | `getScenarioProtect()` A flag indicating whether scenarios are locked when the sheet is protected.
`org.apache.poi.ss.usermodel.SheetConditionalFormatting` | `getSheetConditionalFormatting()`
`java.lang.String` | `getSheetName()` Returns the name of this sheet
`java.util.List` | `getTables()` Returns any tables associated with this Sheet
`short` | `getTopRow()` The top row in the visible view when the sheet is first viewed after opening it in a viewer
`boolean` | `getVerticallyCenter()` Determine whether printed output for this sheet will be vertically centered.
`org.apache.poi.ss.usermodel.Workbook` | `getWorkbook()` Returns the parent XSSFWorkbook
`void` | `groupColumn(int fromColumn, int toColumn)` Group between (0 based) columns
`void` | `groupRow(int fromRow, int toRow)` Tie a range of cell together so that they can be collapsed or expanded
`boolean` | `hasComments()` Does this sheet have any comments on it? We need to know, so we can decide about writing it to disk or not
`boolean` | `isAutoFilterLocked()`
`boolean` | `isColumnBroken(int column)` Determines if there is a page break at the indicated column
`boolean` | `isColumnHidden(int columnIndex)` Get the hidden state for a given column.
`boolean` | `isDeleteColumnsLocked()`
`boolean` | `isDeleteRowsLocked()`
`boolean` | `isDisplayFormulas()` Gets the flag indicating whether this sheet should display formulas.
`boolean` | `isDisplayGridlines()` Gets the flag indicating whether this sheet displays the lines between rows and columns to make editing and reading easier.
`boolean` | `isDisplayRowColHeadings()` Gets the flag indicating whether this sheet should display row and column headings.
`boolean` | `isDisplayZeros()` Gets the flag indicating whether the window should show 0 (zero) in cells containing zero value.
`boolean` | `isFormatCellsLocked()`
`boolean` | `isFormatColumnsLocked()`
`boolean` | `isFormatRowsLocked()`
`boolean` | `isInsertColumnsLocked()`
`boolean` | `isInsertHyperlinksLocked()`
`boolean` | `isInsertRowsLocked()`
`boolean` | `isObjectsLocked()`
`boolean` | `isPivotTablesLocked()`
`boolean` | `isPrintGridlines()` Returns whether gridlines are printed.
`boolean` | `isRightToLeft()` Whether the text is displayed in right-to-left mode in the window
`boolean` | `isRowBroken(int row)` Tests if there is a page break at the indicated row
`boolean` | `isScenariosLocked()`
`boolean` | `isSelected()` Returns a flag indicating whether this sheet is selected.
`boolean` | `isSelectLockedCellsLocked()`
`boolean` | `isSelectUnlockedCellsLocked()`
`boolean` | `isSheetLocked()`
`boolean` | `isSortLocked()`
`java.util.Iterator` | `iterator()` Alias for `rowIterator()` to allow foreach loops
`void` | `lockAutoFilter()` Enable Autofilters locking.
`void` | `lockDeleteColumns()` Enable Deleting columns locking.
`void` | `lockDeleteRows()` Enable Deleting rows locking.
`void` | `lockFormatCells()` Enable Formatting cells locking.
`void` | `lockFormatColumns()` Enable Formatting columns locking.
`void` | `lockFormatRows()` Enable Formatting rows locking.
`void` | `lockInsertColumns()` Enable Inserting columns locking.
`void` | `lockInsertHyperlinks()` Enable Inserting hyperlinks locking.
`void` | `lockInsertRows()` Enable Inserting rows locking.
`void` | `lockObjects()` Enable Objects locking.
`void` | `lockPivotTables()` Enable Pivot Tables locking.
`void` | `lockScenarios()` Enable Scenarios locking.
`void` | `lockSelectLockedCells()` Enable Selection of locked cells locking.
`void` | `lockSelectUnlockedCells()` Enable Selection of unlocked cells locking.
`void` | `lockSort()` Enable Sort locking.
`void` | `protectSheet(java.lang.String password)` Enables sheet protection and sets the password for the sheet.
`org.apache.poi.ss.usermodel.CellRange` | `removeArrayFormula(org.apache.poi.ss.usermodel.Cell cell)`
`void` | `removeColumnBreak(int column)` Removes a page break at the indicated column
`void` | `removeMergedRegion(int index)` Removes a merged region of cells (hence letting them free)
`void` | `removeRow(org.apache.poi.ss.usermodel.Row row)` Remove a row from this sheet.
`void` | `removeRowBreak(int row)` Removes the page break at the indicated row
`java.util.Iterator` | `rowIterator()`
`void` | `setActiveCell(java.lang.String cellRef)` Sets location of the active cell
`org.apache.poi.ss.usermodel.CellRange` | `setArrayFormula(java.lang.String formula, org.apache.poi.ss.util.CellRangeAddress range)`
`void` | `setAutobreaks(boolean value)` Flag indicating whether the sheet displays Automatic Page Breaks.
`org.apache.poi.ss.usermodel.AutoFilter` | `setAutoFilter(org.apache.poi.ss.util.CellRangeAddress range)`
`static void` | `setCellComment(java.lang.String cellRef, XSSFComment comment)` Deprecated. since Nov 2009 use `XSSFCell.setCellComment(org.apache.poi.ss.usermodel.Comment)` instead
`void` | `setColumnBreak(int column)` Sets a page break at the indicated column.
`void` | `setColumnGroupCollapsed(int columnNumber, boolean collapsed)`
`void` | `setColumnHidden(int columnIndex, boolean hidden)` Get the visibility state for a given column.
`void` | `setColumnWidth(int columnIndex, int width)` Set the width (in units of 1/256th of a character width)
`void` | `setDefaultColumnStyle(int column, org.apache.poi.ss.usermodel.CellStyle style)`
`void` | `setDefaultColumnWidth(int width)` Specifies the number of characters of the maximum digit width of the normal style's font.
`void` | `setDefaultRowHeight(short height)` Set the default row height for the sheet (if the rows do not define their own height) in twips (1/20 of a point)
`void` | `setDefaultRowHeightInPoints(float height)` Sets default row height measured in point size.
`void` | `setDisplayFormulas(boolean show)` Sets the flag indicating whether this sheet should display formulas.
`void` | `setDisplayGridlines(boolean show)` Sets the flag indicating whether this sheet should display the lines between rows and columns to make editing and reading easier.
`void` | `setDisplayGuts(boolean value)` Set whether to display the guts or not
`void` | `setDisplayRowColHeadings(boolean show)` Sets the flag indicating whether this sheet should display row and column headings.
`void` | `setDisplayZeros(boolean value)` Set whether the window should show 0 (zero) in cells containing zero value.
`void` | `setFitToPage(boolean b)` Flag indicating whether the Fit to Page print option is enabled.
`void` | `setForceFormulaRecalculation(boolean value)` Control if Excel should be asked to recalculate all formulas on this sheet when the workbook is opened.
`void` | `setHorizontallyCenter(boolean value)` Center on page horizontally when printing.
`void` | `setMargin(short margin, double size)` Sets the size of the margin in inches.
`void` | `setPrintGridlines(boolean value)` Turns on or off the printing of gridlines.
`void` | `setRightToLeft(boolean value)` Sets whether the worksheet is displayed from right to left instead of from left to right.
`void` | `setRowBreak(int row)` Sets a page break at the indicated row Breaks occur above the specified row and left of the specified column inclusive.
`void` | `setRowGroupCollapsed(int rowIndex, boolean collapse)` group the row It is possible for collapsed to be false and yet still have the rows in question hidden.
`void` | `setRowSumsBelow(boolean value)` Flag indicating whether summary rows appear below detail in an outline, when applying an outline.
`void` | `setRowSumsRight(boolean value)` Flag indicating whether summary columns appear to the right of detail in an outline, when applying an outline.
`void` | `setSelected(boolean value)` Sets a flag indicating whether this sheet is selected.
`void` | `setTabColor(int colorIndex)` Set background color of the sheet tab
`void` | `setVerticallyCenter(boolean value)` Whether the output is vertically centered on the page.
`void` | `setZoom(int scale)` Window zoom magnification for current view representing percent values.
`void` | `setZoom(int numerator, int denominator)` Sets the zoom magnication for the sheet.
`void` | `shiftRows(int startRow, int endRow, int n)` Shifts rows between startRow and endRow n number of rows.
`void` | `shiftRows(int startRow, int endRow, int n, boolean copyRowHeight, boolean resetOriginalRowHeight)` Shifts rows between startRow and endRow n number of rows.
`void` | `showInPane(short toprow, short leftcol)` Location of the top left visible cell Location of the top left visible cell in the bottom right pane (when in Left-to-Right mode).
`void` | `ungroupColumn(int fromColumn, int toColumn)`
`void` | `ungroupRow(int fromRow, int toRow)` Ungroup a range of rows that were previously groupped

Methods inherited from class org.apache.poi.POIXMLDocumentPart
`addRelation, createRelationship, createRelationship, getPackagePart, getPackageRelationship, getParent, getRelationById, getRelationId, getRelations, toString`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Method Detail

### getWorkbook

    public org.apache.poi.ss.usermodel.Workbook getWorkbook()

  Returns the parent XSSFWorkbook

  Specified by:
    `getWorkbook` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    the parent XSSFWorkbook

### getCTWorksheet

    public org.openxmlformats.schemas.spreadsheetml.x2006.main.CTWorksheet getCTWorksheet()

  Provide access to the CTWorksheet bean holding this sheet's data

  Returns:
    the CTWorksheet bean holding this sheet's data

### getColumnHelper

    public ColumnHelper getColumnHelper()

### getSheetName

    public java.lang.String getSheetName()

  Returns the name of this sheet

  Specified by:
    `getSheetName` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    the name of this sheet

### addMergedRegion

    public int addMergedRegion(org.apache.poi.ss.util.CellRangeAddress region)

  Adds a merged region of cells (hence those cells form one).

  Specified by:
    `addMergedRegion` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `region` - (rowfrom/colfrom-rowto/colto) to merge
  Returns:
    index of this region

### autoSizeColumn

    public void autoSizeColumn(int column)

  Adjusts the column width to fit the contents. This process can be relatively slow on large sheets, so this should normally only be called once per column, at the end of your processing.

  Specified by:
    `autoSizeColumn` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `column` - the column index

### autoSizeColumn

    public void autoSizeColumn(int column,
                               boolean useMergedCells)

  Adjusts the column width to fit the contents.

  This process can be relatively slow on large sheets, so this should normally only be called once per column, at the end of your processing.

  You can specify whether the content of merged cells should be considered or ignored. Default is to ignore merged cells.

  Specified by:
    `autoSizeColumn` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `column` - the column index
    `useMergedCells` - whether to use the contents of merged cells when calculating the width of the column

### createDrawingPatriarch

    public org.apache.poi.ss.usermodel.Drawing createDrawingPatriarch()

  Create a new SpreadsheetML drawing. If this sheet already contains a drawing - return that.

  Specified by:
    `createDrawingPatriarch` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    a SpreadsheetML drawing

### createFreezePane

    public void createFreezePane(int colSplit,
                                 int rowSplit)

  Creates a split (freezepane). Any existing freezepane or split pane is overwritten.

  Specified by:
    `createFreezePane` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `colSplit` - Horizonatal position of split.
    `rowSplit` - Vertical position of split.

### createFreezePane

    public void createFreezePane(int colSplit,
                                 int rowSplit,
                                 int leftmostColumn,
                                 int topRow)

  Creates a split (freezepane). Any existing freezepane or split pane is overwritten.

  If both colSplit and rowSplit are zero then the existing freeze pane is removed

  Specified by:
    `createFreezePane` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `colSplit` - Horizonatal position of split.
    `rowSplit` - Vertical position of split.
    `leftmostColumn` - Left column visible in right pane.
    `topRow` - Top row visible in bottom pane

### createComment

    public org.apache.poi.ss.usermodel.Comment createComment()

  Deprecated. since Nov 2009 this method is not compatible with the common SS interfaces, use `(org.apache.poi.ss.usermodel.ClientAnchor)` instead

  Creates a new comment for this sheet. You still need to assign it to a cell though

### createRow

    public org.apache.poi.ss.usermodel.Row createRow(int rownum)

  Create a new row within the sheet and return the high level representation

  Specified by:
    `createRow` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `rownum` - row number
  Returns:
    High level `XSSFRow` object representing a row in the sheet
  See Also:
    `removeRow(org.apache.poi.ss.usermodel.Row)`

### createSplitPane

    public void createSplitPane(int xSplitPos,
                                int ySplitPos,
                                int leftmostColumn,
                                int topRow,
                                int activePane)

  Creates a split pane. Any existing freezepane or split pane is overwritten.

  Specified by:
    `createSplitPane` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `xSplitPos` - Horizonatal position of split (in 1/20th of a point).
    `ySplitPos` - Vertical position of split (in 1/20th of a point).
    `topRow` - Top row visible in bottom pane
    `leftmostColumn` - Left column visible in right pane.
    `activePane` - Active pane. One of: PANE_LOWER_RIGHT, PANE_UPPER_RIGHT, PANE_LOWER_LEFT, PANE_UPPER_LEFT
  See Also:
    `Sheet.PANE_LOWER_LEFT`, `Sheet.PANE_LOWER_RIGHT`, `Sheet.PANE_UPPER_LEFT`, `Sheet.PANE_UPPER_RIGHT`

### getCellComment

    public org.apache.poi.ss.usermodel.Comment getCellComment(int row,
                                                              int column)

  Specified by:
    `getCellComment` in interface `org.apache.poi.ss.usermodel.Sheet`

### getHyperlink

    public XSSFHyperlink getHyperlink(int row,
                                      int column)

### getColumnBreaks

    public int[] getColumnBreaks()

  Vertical page break information used for print layout view, page layout view, drawing print breaks in normal view, and for printing the worksheet.

  Specified by:
    `getColumnBreaks` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    column indexes of all the vertical page breaks, never `null`

### getColumnWidth

    public int getColumnWidth(int columnIndex)

  Get the actual column width (in units of 1/256th of a character width )

  Note, the returned value is always gerater that `getDefaultColumnWidth()` because the latter does not include margins. Actual column width measured as the number of characters of the maximum digit width of the numbers 0, 1, 2, ..., 9 as rendered in the normal style's font. There are 4 pixels of margin padding (two on each side), plus 1 pixel padding for the gridlines.

  Specified by:
    `getColumnWidth` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `columnIndex` - - the column to set (0-based)
  Returns:
    width - the width in units of 1/256th of a character width

### getDefaultColumnWidth

    public int getDefaultColumnWidth()

  Get the default column width for the sheet (if the columns do not define their own width) in characters.

  Note, this value is different from `getColumnWidth(int)`. The latter is always greater and includes 4 pixels of margin padding (two on each side), plus 1 pixel padding for the gridlines.

  Specified by:
    `getDefaultColumnWidth` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    column width, default value is 8

### getDefaultRowHeight

    public short getDefaultRowHeight()

  Get the default row height for the sheet (if the rows do not define their own height) in twips (1/20 of a point)

  Specified by:
    `getDefaultRowHeight` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    default row height

### getDefaultRowHeightInPoints

    public float getDefaultRowHeightInPoints()

  Get the default row height for the sheet measued in point size (if the rows do not define their own height).

  Specified by:
    `getDefaultRowHeightInPoints` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    default row height in points

### getColumnStyle

    public org.apache.poi.ss.usermodel.CellStyle getColumnStyle(int column)

  Returns the CellStyle that applies to the given (0 based) column, or null if no style has been set for that column

  Specified by:
    `getColumnStyle` in interface `org.apache.poi.ss.usermodel.Sheet`

### setRightToLeft

    public void setRightToLeft(boolean value)

  Sets whether the worksheet is displayed from right to left instead of from left to right.

  Specified by:
    `setRightToLeft` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - true for right to left, false otherwise.

### isRightToLeft

    public boolean isRightToLeft()

  Whether the text is displayed in right-to-left mode in the window

  Specified by:
    `isRightToLeft` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    whether the text is displayed in right-to-left mode in the window

### getDisplayGuts

    public boolean getDisplayGuts()

  Get whether to display the guts or not, default value is true

  Specified by:
    `getDisplayGuts` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    boolean - guts or no guts

### setDisplayGuts

    public void setDisplayGuts(boolean value)

  Set whether to display the guts or not

  Specified by:
    `setDisplayGuts` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - - guts or no guts

### isDisplayZeros

    public boolean isDisplayZeros()

  Gets the flag indicating whether the window should show 0 (zero) in cells containing zero value. When false, cells with zero value appear blank instead of showing the number zero.

  Specified by:
    `isDisplayZeros` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    whether all zero values on the worksheet are displayed

### setDisplayZeros

    public void setDisplayZeros(boolean value)

  Set whether the window should show 0 (zero) in cells containing zero value. When false, cells with zero value appear blank instead of showing the number zero.

  Specified by:
    `setDisplayZeros` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - whether to display or hide all zero values on the worksheet

### getFirstRowNum

    public int getFirstRowNum()

  Gets the first row on the sheet

  Specified by:
    `getFirstRowNum` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    the number of the first logical row on the sheet, zero based

### getFitToPage

    public boolean getFitToPage()

  Flag indicating whether the Fit to Page print option is enabled.

  Specified by:
    `getFitToPage` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    `true`

### getFooter

    public org.apache.poi.ss.usermodel.Footer getFooter()

  Returns the default footer for the sheet, creating one as needed. You may also want to look at `getFirstFooter()`, `getOddFooter()` and `getEvenFooter()`

  Specified by:
    `getFooter` in interface `org.apache.poi.ss.usermodel.Sheet`

### getHeader

    public org.apache.poi.ss.usermodel.Header getHeader()

  Returns the default header for the sheet, creating one as needed. You may also want to look at `getFirstHeader()`, `getOddHeader()` and `getEvenHeader()`

  Specified by:
    `getHeader` in interface `org.apache.poi.ss.usermodel.Sheet`

### getOddFooter

    public org.apache.poi.ss.usermodel.Footer getOddFooter()

  Returns the odd footer. Used on all pages unless other footers also present, when used on only odd pages.

### getEvenFooter

    public org.apache.poi.ss.usermodel.Footer getEvenFooter()

  Returns the even footer. Not there by default, but when set, used on even pages.

### getFirstFooter

    public org.apache.poi.ss.usermodel.Footer getFirstFooter()

  Returns the first page footer. Not there by default, but when set, used on the first page.

### getOddHeader

    public org.apache.poi.ss.usermodel.Header getOddHeader()

  Returns the odd header. Used on all pages unless other headers also present, when used on only odd pages.

### getEvenHeader

    public org.apache.poi.ss.usermodel.Header getEvenHeader()

  Returns the even header. Not there by default, but when set, used on even pages.

### getFirstHeader

    public org.apache.poi.ss.usermodel.Header getFirstHeader()

  Returns the first page header. Not there by default, but when set, used on the first page.

### getHorizontallyCenter

    public boolean getHorizontallyCenter()

  Determine whether printed output for this sheet will be horizontally centered.

  Specified by:
    `getHorizontallyCenter` in interface `org.apache.poi.ss.usermodel.Sheet`

### getLastRowNum

    public int getLastRowNum()

  Specified by:
    `getLastRowNum` in interface `org.apache.poi.ss.usermodel.Sheet`

### getLeftCol

    public short getLeftCol()

  Specified by:
    `getLeftCol` in interface `org.apache.poi.ss.usermodel.Sheet`

### getMargin

    public double getMargin(short margin)

  Gets the size of the margin in inches.

  Specified by:
    `getMargin` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `margin` - which margin to get
  Returns:
    the size of the margin
  See Also:
    `Sheet.LeftMargin`, `Sheet.RightMargin`, `Sheet.TopMargin`, `Sheet.BottomMargin`, `Sheet.HeaderMargin`, `Sheet.FooterMargin`

### setMargin

    public void setMargin(short margin,
                          double size)

  Sets the size of the margin in inches.

  Specified by:
    `setMargin` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `margin` - which margin to get
    `size` - the size of the margin
  See Also:
    `Sheet.LeftMargin`, `Sheet.RightMargin`, `Sheet.TopMargin`, `Sheet.BottomMargin`, `Sheet.HeaderMargin`, `Sheet.FooterMargin`

### getMergedRegion

    public org.apache.poi.ss.util.CellRangeAddress getMergedRegion(int index)

  Specified by:
    `getMergedRegion` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    the merged region at the specified index
  Throws:
    `java.lang.IllegalStateException` - if this worksheet does not contain merged regions

### getNumMergedRegions

    public int getNumMergedRegions()

  Returns the number of merged regions defined in this worksheet

  Specified by:
    `getNumMergedRegions` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    number of merged regions in this worksheet

### getNumHyperlinks

    public int getNumHyperlinks()

### getPaneInformation

    public org.apache.poi.hssf.util.PaneInformation getPaneInformation()

  Returns the information regarding the currently configured pane (split or freeze).

  Specified by:
    `getPaneInformation` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    null if no pane configured, or the pane information.

### getPhysicalNumberOfRows

    public int getPhysicalNumberOfRows()

  Returns the number of phsyically defined rows (NOT the number of rows in the sheet)

  Specified by:
    `getPhysicalNumberOfRows` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    the number of phsyically defined rows

### getPrintSetup

    public org.apache.poi.ss.usermodel.PrintSetup getPrintSetup()

  Gets the print setup object.

  Specified by:
    `getPrintSetup` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    The user model for the print setup object.

### getProtect

    public boolean getProtect()

  Answer whether protection is enabled or disabled

  Specified by:
    `getProtect` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    true => protection enabled; false => protection disabled

### protectSheet

    public void protectSheet(java.lang.String password)

  Enables sheet protection and sets the password for the sheet. Also sets some attributes on the `CTSheetProtection` that correspond to the default values used by Excel

  Specified by:
    `protectSheet` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `password` - to set for protection. Pass `null` to remove protection

### getRow

    public org.apache.poi.ss.usermodel.Row getRow(int rownum)

  Returns the logical row ( 0-based). If you ask for a row that is not defined you get a null. This is to say row 4 represents the fifth row on a sheet.

  Specified by:
    `getRow` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `rownum` - row to get
  Returns:
    `XSSFRow` representing the rownumber or `null` if its not defined on the sheet

### getRowBreaks

    public int[] getRowBreaks()

  Horizontal page break information used for print layout view, page layout view, drawing print breaks in normal view, and for printing the worksheet.

  Specified by:
    `getRowBreaks` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    row indexes of all the horizontal page breaks, never `null`

### getRowSumsBelow

    public boolean getRowSumsBelow()

  Flag indicating whether summary rows appear below detail in an outline, when applying an outline.

  When true a summary row is inserted below the detailed data being summarized and a new outline level is established on that row.

  When false a summary row is inserted above the detailed data being summarized and a new outline level is established on that row.

  Specified by:
    `getRowSumsBelow` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    `true` if row summaries appear below detail in the outline

### setRowSumsBelow

    public void setRowSumsBelow(boolean value)

  Flag indicating whether summary rows appear below detail in an outline, when applying an outline.

  When true a summary row is inserted below the detailed data being summarized and a new outline level is established on that row.

  When false a summary row is inserted above the detailed data being summarized and a new outline level is established on that row.

  Specified by:
    `setRowSumsBelow` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - `true` if row summaries appear below detail in the outline

### getRowSumsRight

    public boolean getRowSumsRight()

  Flag indicating whether summary columns appear to the right of detail in an outline, when applying an outline.

  When true a summary column is inserted to the right of the detailed data being summarized and a new outline level is established on that column.

  When false a summary column is inserted to the left of the detailed data being summarized and a new outline level is established on that column.

  Specified by:
    `getRowSumsRight` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    `true` if col summaries appear right of the detail in the outline

### setRowSumsRight

    public void setRowSumsRight(boolean value)

  Flag indicating whether summary columns appear to the right of detail in an outline, when applying an outline.

  When true a summary column is inserted to the right of the detailed data being summarized and a new outline level is established on that column.

  When false a summary column is inserted to the left of the detailed data being summarized and a new outline level is established on that column.

  Specified by:
    `setRowSumsRight` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - `true` if col summaries appear right of the detail in the outline

### getScenarioProtect

    public boolean getScenarioProtect()

  A flag indicating whether scenarios are locked when the sheet is protected.

  Specified by:
    `getScenarioProtect` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    true => protection enabled; false => protection disabled

### getTopRow

    public short getTopRow()

  The top row in the visible view when the sheet is first viewed after opening it in a viewer

  Specified by:
    `getTopRow` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    integer indicating the rownum (0 based) of the top row

### getVerticallyCenter

    public boolean getVerticallyCenter()

  Determine whether printed output for this sheet will be vertically centered.

  Specified by:
    `getVerticallyCenter` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    whether printed output for this sheet will be vertically centered.

### groupColumn

    public void groupColumn(int fromColumn,
                            int toColumn)

  Group between (0 based) columns

  Specified by:
    `groupColumn` in interface `org.apache.poi.ss.usermodel.Sheet`

### groupRow

    public void groupRow(int fromRow,
                         int toRow)

  Tie a range of cell together so that they can be collapsed or expanded

  Specified by:
    `groupRow` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `fromRow` - start row (0-based)
    `toRow` - end row (0-based)

### isColumnBroken

    public boolean isColumnBroken(int column)

  Determines if there is a page break at the indicated column

  Specified by:
    `isColumnBroken` in interface `org.apache.poi.ss.usermodel.Sheet`

### isColumnHidden

    public boolean isColumnHidden(int columnIndex)

  Get the hidden state for a given column.

  Specified by:
    `isColumnHidden` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `columnIndex` - - the column to set (0-based)
  Returns:
    hidden - `false` if the column is visible

### isDisplayFormulas

    public boolean isDisplayFormulas()

  Gets the flag indicating whether this sheet should display formulas.

  Specified by:
    `isDisplayFormulas` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    `true` if this sheet should display formulas.

### isDisplayGridlines

    public boolean isDisplayGridlines()

  Gets the flag indicating whether this sheet displays the lines between rows and columns to make editing and reading easier.

  Specified by:
    `isDisplayGridlines` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    `true` if this sheet displays gridlines.
  See Also:
    `to check if printing of gridlines is turned on or off`

### setDisplayGridlines

    public void setDisplayGridlines(boolean show)

  Sets the flag indicating whether this sheet should display the lines between rows and columns to make editing and reading easier. To turn printing of gridlines use `setPrintGridlines(boolean)`

  Specified by:
    `setDisplayGridlines` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `show` - `true` if this sheet should display gridlines.
  See Also:
    `setPrintGridlines(boolean)`

### isDisplayRowColHeadings

    public boolean isDisplayRowColHeadings()

  Gets the flag indicating whether this sheet should display row and column headings.

  Row heading are the row numbers to the side of the sheet

  Column heading are the letters or numbers that appear above the columns of the sheet

  Specified by:
    `isDisplayRowColHeadings` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    `true` if this sheet should display row and column headings.

### setDisplayRowColHeadings

    public void setDisplayRowColHeadings(boolean show)

  Sets the flag indicating whether this sheet should display row and column headings.

  Row heading are the row numbers to the side of the sheet

  Column heading are the letters or numbers that appear above the columns of the sheet

  Specified by:
    `setDisplayRowColHeadings` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `show` - `true` if this sheet should display row and column headings.

### isPrintGridlines

    public boolean isPrintGridlines()

  Returns whether gridlines are printed.

  Specified by:
    `isPrintGridlines` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    whether gridlines are printed

### setPrintGridlines

    public void setPrintGridlines(boolean value)

  Turns on or off the printing of gridlines.

  Specified by:
    `setPrintGridlines` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - boolean to turn on or off the printing of gridlines

### isRowBroken

    public boolean isRowBroken(int row)

  Tests if there is a page break at the indicated row

  Specified by:
    `isRowBroken` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `row` - index of the row to test
  Returns:
    `true` if there is a page break at the indicated row

### setRowBreak

    public void setRowBreak(int row)

  Sets a page break at the indicated row Breaks occur above the specified row and left of the specified column inclusive. For example, `sheet.setColumnBreak(2);` breaks the sheet into two parts with columns A,B,C in the first and D,E,... in the second. Simuilar, `sheet.setRowBreak(2);` breaks the sheet into two parts with first three rows (rownum=1...3) in the first part and rows starting with rownum=4 in the second.

  Specified by:
    `setRowBreak` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `row` - the row to break, inclusive

### removeColumnBreak

    public void removeColumnBreak(int column)

  Removes a page break at the indicated column

  Specified by:
    `removeColumnBreak` in interface `org.apache.poi.ss.usermodel.Sheet`

### removeMergedRegion

    public void removeMergedRegion(int index)

  Removes a merged region of cells (hence letting them free)

  Specified by:
    `removeMergedRegion` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `index` - of the region to unmerge

### removeRow

    public void removeRow(org.apache.poi.ss.usermodel.Row row)

  Remove a row from this sheet. All cells contained in the row are removed as well

  Specified by:
    `removeRow` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `row` - the row to remove.

### removeRowBreak

    public void removeRowBreak(int row)

  Removes the page break at the indicated row

  Specified by:
    `removeRowBreak` in interface `org.apache.poi.ss.usermodel.Sheet`

### setForceFormulaRecalculation

    public void setForceFormulaRecalculation(boolean value)

  Control if Excel should be asked to recalculate all formulas on this sheet when the workbook is opened.

  Calculating the formula values with `FormulaEvaluator` is the recommended solution, but this may be used for certain cases where evaluation in POI is not possible.

  It is recommended to force recalcuation of formulas on workbook level using `Workbook.setForceFormulaRecalculation(boolean)` to ensure that all cross-worksheet formuals and external dependencies are updated.

  Specified by:
    `setForceFormulaRecalculation` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - true if the application will perform a full recalculation of this worksheet values when the workbook is opened
  See Also:
    `Workbook.setForceFormulaRecalculation(boolean)`

### getForceFormulaRecalculation

    public boolean getForceFormulaRecalculation()

  Whether Excel will be asked to recalculate all formulas when the workbook is opened.

  Specified by:
    `getForceFormulaRecalculation` in interface `org.apache.poi.ss.usermodel.Sheet`

### rowIterator

    public java.util.Iterator rowIterator()

  Specified by:
    `rowIterator` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    an iterator of the PHYSICAL rows. Meaning the 3rd element may not be the third row if say for instance the second row is undefined. Call getRowNum() on each row if you care which one it is.

### iterator

    public java.util.Iterator iterator()

  Alias for `rowIterator()` to allow foreach loops

  Specified by:
    `iterator` in interface `poi.support.Iterable`

### getAutobreaks

    public boolean getAutobreaks()

  Flag indicating whether the sheet displays Automatic Page Breaks.

  Specified by:
    `getAutobreaks` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    `true` if the sheet displays Automatic Page Breaks.

### setAutobreaks

    public void setAutobreaks(boolean value)

  Flag indicating whether the sheet displays Automatic Page Breaks.

  Specified by:
    `setAutobreaks` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - `true` if the sheet displays Automatic Page Breaks.

### setColumnBreak

    public void setColumnBreak(int column)

  Sets a page break at the indicated column. Breaks occur above the specified row and left of the specified column inclusive. For example, `sheet.setColumnBreak(2);` breaks the sheet into two parts with columns A,B,C in the first and D,E,... in the second. Simuilar, `sheet.setRowBreak(2);` breaks the sheet into two parts with first three rows (rownum=1...3) in the first part and rows starting with rownum=4 in the second.

  Specified by:
    `setColumnBreak` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `column` - the column to break, inclusive

### setColumnGroupCollapsed

    public void setColumnGroupCollapsed(int columnNumber,
                                        boolean collapsed)

  Specified by:
    `setColumnGroupCollapsed` in interface `org.apache.poi.ss.usermodel.Sheet`

### setColumnHidden

    public void setColumnHidden(int columnIndex,
                                boolean hidden)

  Get the visibility state for a given column.

  Specified by:
    `setColumnHidden` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `columnIndex` - - the column to get (0-based)
    `hidden` - - the visiblity state of the column

### setColumnWidth

    public void setColumnWidth(int columnIndex,
                               int width)

  Set the width (in units of 1/256th of a character width)

  The maximum column width for an individual cell is 255 characters. This value represents the number of characters that can be displayed in a cell that is formatted with the standard font (first font in the workbook).

  Character width is defined as the maximum digit width of the numbers `0, 1, 2, ... 9` as rendered using the default font (first font in the workbook).
  Unless you are using a very special font, the default character is '0' (zero), this is true for Arial (default font font in HSSF) and Calibri (default font in XSSF)

  Please note, that the width set by this method includes 4 pixels of margin padding (two on each side), plus 1 pixel padding for the gridlines (Section 3.3.1.12 of the OOXML spec). This results is a slightly less value of visible characters than passed to this method (approx. 1/2 of a character).

  To compute the actual number of visible characters, Excel uses the following formula (Section 3.3.1.12 of the OOXML spec):

  `width = Truncate([{Number of Visible Characters} * {Maximum Digit Width} + {5 pixel padding}]/{Maximum Digit Width}*256)/256`

  Using the Calibri font as an example, the maximum digit width of 11 point font size is 7 pixels (at 96 dpi). If you set a column width to be eight characters wide, e.g. `setColumnWidth(columnIndex, 8*256)`, then the actual value of visible characters (the value shown in Excel) is derived from the following equation: `Truncate([numChars*7+5]/7*256)/256 = 8;` which gives `7.29`.

  Specified by:
    `setColumnWidth` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `columnIndex` - - the column to set (0-based)
    `width` - - the width in units of 1/256th of a character width
  Throws:
    `java.lang.IllegalArgumentException` - if width > 255*256 (the maximum column width in Excel is 255 characters)

### setDefaultColumnStyle

    public void setDefaultColumnStyle(int column,
                                      org.apache.poi.ss.usermodel.CellStyle style)

  Specified by:
    `setDefaultColumnStyle` in interface `org.apache.poi.ss.usermodel.Sheet`

### setDefaultColumnWidth

    public void setDefaultColumnWidth(int width)

  Specifies the number of characters of the maximum digit width of the normal style's font. This value does not include margin padding or extra padding for gridlines. It is only the number of characters.

  Specified by:
    `setDefaultColumnWidth` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `width` - the number of characters. Default value is `8`.

### setDefaultRowHeight

    public void setDefaultRowHeight(short height)

  Set the default row height for the sheet (if the rows do not define their own height) in twips (1/20 of a point)

  Specified by:
    `setDefaultRowHeight` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `height` - default row height in twips (1/20 of a point)

### setDefaultRowHeightInPoints

    public void setDefaultRowHeightInPoints(float height)

  Sets default row height measured in point size.

  Specified by:
    `setDefaultRowHeightInPoints` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `height` - default row height measured in point size.

### setDisplayFormulas

    public void setDisplayFormulas(boolean show)

  Sets the flag indicating whether this sheet should display formulas.

  Specified by:
    `setDisplayFormulas` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `show` - `true` if this sheet should display formulas.

### setFitToPage

    public void setFitToPage(boolean b)

  Flag indicating whether the Fit to Page print option is enabled.

  Specified by:
    `setFitToPage` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `b` - `true` if the Fit to Page print option is enabled.

### setHorizontallyCenter

    public void setHorizontallyCenter(boolean value)

  Center on page horizontally when printing.

  Specified by:
    `setHorizontallyCenter` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - whether to center on page horizontally when printing.

### setVerticallyCenter

    public void setVerticallyCenter(boolean value)

  Whether the output is vertically centered on the page.

  Specified by:
    `setVerticallyCenter` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - true to vertically center, false otherwise.

### setRowGroupCollapsed

    public void setRowGroupCollapsed(int rowIndex,
                                     boolean collapse)

  group the row It is possible for collapsed to be false and yet still have the rows in question hidden. This can be achieved by having a lower outline level collapsed, thus hiding all the child rows. Note that in this case, if the lowest level were expanded, the middle level would remain collapsed.

  Specified by:
    `setRowGroupCollapsed` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `rowIndex` - - the row involved, 0 based
    `collapse` - - boolean value for collapse

### findEndOfRowOutlineGroup

    public int findEndOfRowOutlineGroup(int row)

  Parameters:
    `row` - the zero based row index to find from

### setZoom

    public void setZoom(int numerator,
                        int denominator)

  Sets the zoom magnication for the sheet. The zoom is expressed as a fraction. For example to express a zoom of 75% use 3 for the numerator and 4 for the denominator.

  Specified by:
    `setZoom` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `numerator` - The numerator for the zoom magnification.
    `denominator` - The denominator for the zoom magnification.
  See Also:
    `setZoom(int)`

### setZoom

    public void setZoom(int scale)

  Window zoom magnification for current view representing percent values. Valid values range from 10 to 400. Horizontal & Vertical scale together. For example:

       10 - 10%
       20 - 20%
       ...
       100 - 100%
       ...
       400 - 400%

  Current view can be Normal, Page Layout, or Page Break Preview.

  Parameters:
    `scale` - window zoom magnification
  Throws:
    `java.lang.IllegalArgumentException` - if scale is invalid

### shiftRows

    public void shiftRows(int startRow,
                          int endRow,
                          int n)

  Shifts rows between startRow and endRow n number of rows. If you use a negative number, it will shift rows up. Code ensures that rows don't wrap around. Calls shiftRows(startRow, endRow, n, false, false);

  Additionally shifts merged regions that are completely defined in these rows (ie. merged 2 cells on a row to be shifted).

  Specified by:
    `shiftRows` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `startRow` - the row to start shifting
    `endRow` - the row to end shifting
    `n` - the number of rows to shift

### shiftRows

    public void shiftRows(int startRow,
                          int endRow,
                          int n,
                          boolean copyRowHeight,
                          boolean resetOriginalRowHeight)

  Shifts rows between startRow and endRow n number of rows. If you use a negative number, it will shift rows up. Code ensures that rows don't wrap around

  Additionally shifts merged regions that are completely defined in these rows (ie. merged 2 cells on a row to be shifted).

  Specified by:
    `shiftRows` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `startRow` - the row to start shifting
    `endRow` - the row to end shifting
    `n` - the number of rows to shift
    `copyRowHeight` - whether to copy the row height during the shift
    `resetOriginalRowHeight` - whether to set the original row's height to the default

### showInPane

    public void showInPane(short toprow,
                           short leftcol)

  Location of the top left visible cell Location of the top left visible cell in the bottom right pane (when in Left-to-Right mode).

  Specified by:
    `showInPane` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `toprow` - the top row to show in desktop window pane
    `leftcol` - the left column to show in desktop window pane

### ungroupColumn

    public void ungroupColumn(int fromColumn,
                              int toColumn)

  Specified by:
    `ungroupColumn` in interface `org.apache.poi.ss.usermodel.Sheet`

### ungroupRow

    public void ungroupRow(int fromRow,
                           int toRow)

  Ungroup a range of rows that were previously groupped

  Specified by:
    `ungroupRow` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `fromRow` - start row (0-based)
    `toRow` - end row (0-based)

### isSelected

    public boolean isSelected()

  Returns a flag indicating whether this sheet is selected.

  When only 1 sheet is selected and active, this value should be in synch with the activeTab value. In case of a conflict, the Start Part setting wins and sets the active sheet tab.

  Note: multiple sheets can be selected, but only one sheet can be active at one time.

  Specified by:
    `isSelected` in interface `org.apache.poi.ss.usermodel.Sheet`
  Returns:
    `true` if this sheet is selected

### setSelected

    public void setSelected(boolean value)

  Sets a flag indicating whether this sheet is selected.

  When only 1 sheet is selected and active, this value should be in synch with the activeTab value. In case of a conflict, the Start Part setting wins and sets the active sheet tab.

  Note: multiple sheets can be selected, but only one sheet can be active at one time.

  Specified by:
    `setSelected` in interface `org.apache.poi.ss.usermodel.Sheet`
  Parameters:
    `value` - `true` if this sheet is selected

### setCellComment

    public static void setCellComment(java.lang.String cellRef,
                                      XSSFComment comment)

  Deprecated. since Nov 2009 use `XSSFCell.setCellComment(org.apache.poi.ss.usermodel.Comment)` instead

  Assign a cell comment to a cell region in this worksheet

  Parameters:
    `cellRef` - cell region
    `comment` - the comment to assign

### addHyperlink

    public void addHyperlink(XSSFHyperlink hyperlink)

  Register a hyperlink in the collection of hyperlinks on this sheet

  Parameters:
    `hyperlink` - the link to add

### getActiveCell

    public java.lang.String getActiveCell()

  Return location of the active cell, e.g. `A1`.

  Returns:
    the location of the active cell.

### setActiveCell

    public void setActiveCell(java.lang.String cellRef)

  Sets location of the active cell

  Parameters:
    `cellRef` - the location of the active cell, e.g. `A1`..

### hasComments

    public boolean hasComments()

  Does this sheet have any comments on it? We need to know, so we can decide about writing it to disk or not

### isAutoFilterLocked

    public boolean isAutoFilterLocked()

  Returns:
    true when Autofilters are locked and the sheet is protected.

### isDeleteColumnsLocked

    public boolean isDeleteColumnsLocked()

  Returns:
    true when Deleting columns is locked and the sheet is protected.

### isDeleteRowsLocked

    public boolean isDeleteRowsLocked()

  Returns:
    true when Deleting rows is locked and the sheet is protected.

### isFormatCellsLocked

    public boolean isFormatCellsLocked()

  Returns:
    true when Formatting cells is locked and the sheet is protected.

### isFormatColumnsLocked

    public boolean isFormatColumnsLocked()

  Returns:
    true when Formatting columns is locked and the sheet is protected.

### isFormatRowsLocked

    public boolean isFormatRowsLocked()

  Returns:
    true when Formatting rows is locked and the sheet is protected.

### isInsertColumnsLocked

    public boolean isInsertColumnsLocked()

  Returns:
    true when Inserting columns is locked and the sheet is protected.

### isInsertHyperlinksLocked

    public boolean isInsertHyperlinksLocked()

  Returns:
    true when Inserting hyperlinks is locked and the sheet is protected.

### isInsertRowsLocked

    public boolean isInsertRowsLocked()

  Returns:
    true when Inserting rows is locked and the sheet is protected.

### isPivotTablesLocked

    public boolean isPivotTablesLocked()

  Returns:
    true when Pivot tables are locked and the sheet is protected.

### isSortLocked

    public boolean isSortLocked()

  Returns:
    true when Sorting is locked and the sheet is protected.

### isObjectsLocked

    public boolean isObjectsLocked()

  Returns:
    true when Objects are locked and the sheet is protected.

### isScenariosLocked

    public boolean isScenariosLocked()

  Returns:
    true when Scenarios are locked and the sheet is protected.

### isSelectLockedCellsLocked

    public boolean isSelectLockedCellsLocked()

  Returns:
    true when Selection of locked cells is locked and the sheet is protected.

### isSelectUnlockedCellsLocked

    public boolean isSelectUnlockedCellsLocked()

  Returns:
    true when Selection of unlocked cells is locked and the sheet is protected.

### isSheetLocked

    public boolean isSheetLocked()

  Returns:
    true when Sheet is Protected.

### enableLocking

    public void enableLocking()

  Enable sheet protection

### disableLocking

    public void disableLocking()

  Disable sheet protection

### lockAutoFilter

    public void lockAutoFilter()

  Enable Autofilters locking. This does not modify sheet protection status. To enforce this locking, call `enableLocking()`

### lockDeleteColumns

    public void lockDeleteColumns()

  Enable Deleting columns locking. This does not modify sheet protection status. To enforce this locking, call `enableLocking()`

### lockDeleteRows

    public void lockDeleteRows()

  Enable Deleting rows locking. This does not modify sheet protection status. To enforce this locking, call `enableLocking()`

### lockFormatCells

    public void lockFormatCells()

  Enable Formatting cells locking. This does not modify sheet protection status. To enforce this locking, call `enableLocking()`

### lockFormatColumns

    public void lockFormatColumns()

  Enable Formatting columns locking. This does not modify sheet protection status. To enforce this locking, call `enableLocking()`

### lockFormatRows

    public void lockFormatRows()

  Enable Formatting rows locking. This does not modify sheet protection status. To enforce this locking, call `enableLocking()`

### lockInsertColumns

    public void lockInsertColumns()

  Enable Inserting columns locking. This does not modify sheet protection status. To enforce this locking, call `enableLocking()`

### lockInsertHyperlinks

    public void lockInsertHyperlinks()

  Enable Inserting hyperlinks locking. This does not modify sheet protection status. To enforce this locking, call `enableLocking()`

### lockInsertRows

    public void lockInsertRows()

  Enable Inserting rows locking. This does not modify sheet protection status. To enforce this locking, call `enableLocking()`

### lockPivotTables

    public void lockPivotTables()

  Enable Pivot Tables locking. This does not modify sheet protection status. To enforce this locking, call `enableLocking()`

### lockSort

    public void lockSort()

  Enable Sort locking. This does not modify sheet protection status. To enforce this locking, call `enableLocking()`

### lockObjects

    public void lockObjects()

  Enable Objects locking. This does not modify sheet protection status. To enforce this locking, call `enableLocking()`

### lockScenarios

    public void lockScenarios()

  Enable Scenarios locking. This does not modify sheet protection status. To enforce this locking, call `enableLocking()`

### lockSelectLockedCells

    public void lockSelectLockedCells()

  Enable Selection of locked cells locking. This does not modify sheet protection status. To enforce this locking, call `enableLocking()`

### lockSelectUnlockedCells

    public void lockSelectUnlockedCells()

  Enable Selection of unlocked cells locking. This does not modify sheet protection status. To enforce this locking, call `enableLocking()`

### setArrayFormula

    public org.apache.poi.ss.usermodel.CellRange setArrayFormula(java.lang.String formula,
                                                                 org.apache.poi.ss.util.CellRangeAddress range)

  Specified by:
    `setArrayFormula` in interface `org.apache.poi.ss.usermodel.Sheet`

### removeArrayFormula

    public org.apache.poi.ss.usermodel.CellRange removeArrayFormula(org.apache.poi.ss.usermodel.Cell cell)

  Specified by:
    `removeArrayFormula` in interface `org.apache.poi.ss.usermodel.Sheet`

### getDataValidationHelper

    public org.apache.poi.ss.usermodel.DataValidationHelper getDataValidationHelper()

  Specified by:
    `getDataValidationHelper` in interface `org.apache.poi.ss.usermodel.Sheet`

### getDataValidations

    public java.util.List getDataValidations()

### addValidationData

    public void addValidationData(org.apache.poi.ss.usermodel.DataValidation dataValidation)

  Specified by:
    `addValidationData` in interface `org.apache.poi.ss.usermodel.Sheet`

### setAutoFilter

    public org.apache.poi.ss.usermodel.AutoFilter setAutoFilter(org.apache.poi.ss.util.CellRangeAddress range)

  Specified by:
    `setAutoFilter` in interface `org.apache.poi.ss.usermodel.Sheet`

### createTable

    public XSSFTable createTable()

  Creates a new Table, and associates it with this Sheet

### getTables

    public java.util.List getTables()

  Returns any tables associated with this Sheet

### getSheetConditionalFormatting

    public org.apache.poi.ss.usermodel.SheetConditionalFormatting getSheetConditionalFormatting()

  Specified by:
    `getSheetConditionalFormatting` in interface `org.apache.poi.ss.usermodel.Sheet`

### setTabColor

    public void setTabColor(int colorIndex)

  Set background color of the sheet tab

  Parameters:
    `colorIndex` - the indexed color to set, must be a constant from `IndexedColors`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD